#include "USBCOM_def.h"
#include <conio.h>
/* ------------------------------ */
/*   𐔒lɕϊ           */
/*                                */
/*  "18.52.86.120" -> 0x78563412  */
/* ------------------------------ */
EPN_DWORD IPAddrToDword( char *strIP )
{
	EPN_DWORD dwIP = 0x0;
	EPN_BYTE  byIP[4];

	char strTmp[5];

	int i, j, k;

	i = 0; j = 0; k = 0;

	while( 1 ) {

		strTmp[j] = *(strIP + i);

		if( *(strIP+i) == '.' || *(strIP+i) == '\0' ) {

			strTmp[j] = 0x00;

			byIP[k++] = atoi( strTmp ); 

			if( *(strIP + i) == '\0' ) {

				dwIP = byIP[3] << 24 | byIP[2] << 16 | byIP[1] << 8 | byIP[0];

				break;
			}

			j = 0; i++;
		}
		else {

			i++; j++;
		}
	}

	return dwIP;
}

void EpnSetDataPort( EPN_WORD data )
{
	while ( (GetFlg() & (FLG_WRITE_FULL | FLG_WRITE_ENABLE)) != FLG_WRITE_ENABLE );

	SetDat( data );
}

EPN_WORD EpnGetDataPort(void)
{
	EPN_WORD data;

	while ( (GetFlg() & FLG_READ_FULL) != FLG_READ_FULL );

	data = GetDat();

	return data;
}

void EpnSetBlockDataPort( EPN_WORD* data, EPN_WORD length )
{
	while (length--) {

		while ( (GetFlg() & (FLG_WRITE_FULL | FLG_WRITE_ENABLE)) != FLG_WRITE_ENABLE ); 
		
		SetDat( *data++ );
	}
}

void EpnGetBlockDataPort( EPN_WORD* data, EPN_WORD length )
{
	while (length--) {

		while ( (GetFlg() & FLG_READ_FULL) != FLG_READ_FULL ); 
		
		*data++ = GetDat();
	}

	return;
}

void EpnInit()
{
	EPN_WORD status;
	EPN_WORD SeqNum = 0x0000;

	status = GetSts();

	while( ( SeqNum | status ) != (SeqNum | STS_BOOT) ) {

		SetCmd( SeqNum | CMD_INIT );
		
		status = GetSts();
	}
}

void EpnSystemOpen(char* szEpnIP, char* szMaskIP, char* szGateIP, char* szRmtIP)
{
	EPN_WORD  SeqNum = 0x0100;
	EPN_DWORD dwEpnIP, dwMaskIP, dwGateIP, dwFlag, dwRmtIP;

	//EPNƐڑIP
	dwRmtIP = IPAddrToDword(szRmtIP);

	//KvɉĕύXĉ
	dwEpnIP  = IPAddrToDword(szEpnIP);  // EPNAhX
	dwMaskIP = IPAddrToDword(szMaskIP); // Tulbg}XN
	dwGateIP = IPAddrToDword(szGateIP); // Q[gEFC

	dwFlag   = ENB_SELF_IP | ENB_SUBMASK | ENB_GATEWAY;

	// R}ht\Ԃׂ 
	// bit2  1  0 ɂȂƔ
	while( GetFlg() & FLG_COMMAND_FULL );

	// VXe(0)I[v 
	SetCmd( SeqNum | CMD_OPEN );

	// Xe[^XZbgꂽƂF
	while( GetFlg() & FLG_STAUS_FULL != FLG_STAUS_FULL );

	// Xe[^Xǂݏo
	while( GetSts() != ( SeqNum | STS_WRITE ) );

	EpnSetDataPort( 0x0000 );
	// tO
	EpnSetDataPort( LOWORD( dwFlag ) );

	// EPN IP AhX
	SetDat( LOWORD( dwEpnIP ) );
	SetDat( HIWORD( dwEpnIP ) );
	
	// Tulbg}XN
	EpnSetDataPort( LOWORD( dwMaskIP ) );
	EpnSetDataPort( HIWORD( dwMaskIP ) );

	// Q[gEFC
	EpnSetDataPort( LOWORD( dwGateIP ) );
	EpnSetDataPort( HIWORD( dwGateIP ) );

	// Xe[^XZbgꂽƂF
	while( GetFlg() & FLG_STAUS_FULL != FLG_STAUS_FULL );

	// Xe[^Xǂݏo
	while( GetSts() != ( SeqNum | STS_OK ) );

//	printf("System Open OK\n");
}

void EpnUdpOpen( char* szDsIP )
{
	EPN_WORD  SeqNum   = 0x0200;
	EPN_WORD  wRmtPort = 1234;
	EPN_DWORD dwRmtIP;

	dwRmtIP = IPAddrToDword(szDsIP);

	// R}ht\Ԃׂ 
	// bit2  1  0 ɂȂƔ
	while( GetFlg() & FLG_COMMAND_FULL );

	// UDPI[v
	SetCmd( SeqNum | ENDPOINT_UDP0 | CMD_OPEN );

	// Xe[^XZbgꂽƂF
	while( GetFlg() & FLG_STAUS_FULL != FLG_STAUS_FULL );

	// Xe[^Xǂݏo
	while( GetSts() != ( SeqNum | ENDPOINT_UDP0 | STS_WRITE ) );

//	printf("flag : / 0x%x\n", ENB_ACTIVE | ENB_REMOTE_IP | ENB_REMOTE_PORT | ENB_SELF_PORT );
//	printf("RIP  : / 0x%x\n", dwRmtIP );
//	printf("SEL  : / 0x%x\n", (wRmtPort << 8) | (wRmtPort >> 8) );

	EpnSetDataPort( 0x0000 );
	EpnSetDataPort( LOWORD( ENB_ACTIVE | ENB_REMOTE_IP | ENB_REMOTE_PORT | ENB_SELF_PORT ) );

	EpnSetDataPort( LOWORD(dwRmtIP) ); //printf("%x\n",LOWORD(dwRmtIP));;
	EpnSetDataPort( HIWORD(dwRmtIP) ); //printf("%x\n",HIWORD(dwRmtIP));
	
	EpnSetDataPort( (wRmtPort << 8) | (wRmtPort >> 8) );//printf("%x\n",(wRmtPort << 8) | (wRmtPort >> 8));
	EpnSetDataPort( (wRmtPort << 8) | (wRmtPort >> 8) );

	EpnSetDataPort( 0x0000 );
	EpnSetDataPort( 0x0000 );

	// Xe[^XZbgꂽƂF
	while( GetFlg() & FLG_STAUS_FULL != FLG_STAUS_FULL );

	// Xe[^Xǂݏo
	while( GetSts() != ( SeqNum | ENDPOINT_UDP0 | STS_OK ) );

//	printf("UDP Open OK\n");
}

void EpnUdpSend( char* str )
{
	int i, len;
	WORD wlen, wStr;
	EPN_WORD  SeqNum = 0x0300;

	// R}ht\Ԃׂ 
	// bit2  1  0 ɂȂƔ
	while( GetFlg() & FLG_COMMAND_FULL );

	// UDP[_ɕ𑗐M
	SetCmd( SeqNum | ENDPOINT_UDP0 | CMD_SEND );

	// Xe[^XZbgꂽƂF
	while( GetFlg() & FLG_STAUS_FULL != FLG_STAUS_FULL );

	// Xe[^Xǂݏo
	while( GetSts() != ( SeqNum | ENDPOINT_UDP0 | STS_WRITE ) );

	len  = strlen( str );
	wlen = (len << 8) | (len >> 8) ;

	// Mf[^
	EpnSetDataPort( wlen );   // 1 0
	// tO
	EpnSetDataPort(0x0000);   // 3 2 
	EpnSetDataPort(0x0000);   // 5 4
	EpnSetDataPort(0x0000);   // 7 6
	EpnSetDataPort(0x0000);   // 9 8

	EpnSetDataPort( 0x0000 ); //11 10
	EpnSetDataPort( 0x0000 ); //13 12
	EpnSetDataPort( 0x0000 ); //15 14

	// Mf[^
	for( i=0; i<len; i=i+2 ) {
	
		wStr = MAKEWORD( str[i], str[i+1] );

		SetDat( wStr );
	}

	// Xe[^XZbgꂽƂF
	while( GetFlg() & FLG_STAUS_FULL != FLG_STAUS_FULL );

	// Xe[^Xǂݏo
	while( GetSts() != ( SeqNum | ENDPOINT_UDP0 | STS_OK ) );

//	printf("UDP SEND OK\n");
}

int EpnUdpReceive( char* str )
{
	WORD i, j, wlen, blen, nBytes;
	EPN_WORD  SeqNum = 0x0400;
	EPN_WORD  r;

	//M
	if( ( 0x000F & GetSts() ) != 0x0d )
		return 0;

//	printf("f[^|[g̓Ǎ\n", GetSts() );

	// R}ht\Ԃׂ 
	// bit2  1  0 ɂȂƔ
	while( GetFlg() & FLG_COMMAND_FULL );

	SetCmd( SeqNum | ENDPOINT_UDP0 | CMD_RECEIVE );

	while( GetSts() != ( SeqNum | ENDPOINT_UDP0 | STS_READ ) );


	blen= EpnGetDataPort(); //printf(" 0  1: %x\n", blen );
	r   = EpnGetDataPort(); //printf(" 2  3: %x\n", r);
	r   = EpnGetDataPort(); //printf(" 4  5: %x\n", r);
	r   = EpnGetDataPort(); //printf(" 6  7: %x\n", r);
	r   = EpnGetDataPort(); //printf(" 8  9: %x\n", r);
	r   = EpnGetDataPort(); //printf("10 11: %x\n", r);
	r   = EpnGetDataPort(); //printf("12 13: %x\n", r);
	r   = EpnGetDataPort(); //printf("14 15: %x\n", r);

	nBytes = wlen = (blen >> 8) | (blen << 8);

	if( wlen%2 != 0 ) 
		wlen++;
	wlen = wlen / 2;

	j=0;
	for( i=0; i<wlen; i++ ) {
		r = EpnGetDataPort(); //printf("12 13: %x\n", r);

		str[j]   = r & 0xFF; j=j+1;
		str[j] = r >> 8;   j=j+1;
	}

	str[blen+1] = 0;

	return nBytes; //M
}

void EpnUdpClose( )
{
	EPN_WORD  SeqNum   = 0x0500;

	// R}ht\Ԃׂ 
	// bit2  1  0 ɂȂƔ
	while( GetFlg() & FLG_COMMAND_FULL );

	// UDP0[_
	SetCmd( SeqNum | ENDPOINT_UDP0 | CMD_CLOSE );
	// Xe[^XZbgꂽƂF
	while( GetFlg() & FLG_STAUS_FULL != FLG_STAUS_FULL );
	// OK(3)ԂĂ܂ő҂
	while( GetSts() != ( SeqNum | ENDPOINT_UDP0 | STS_OK ) );

//	printf("UDP Close OK\n");

	return ;
}

EPN_WORD Epn_Reg_READ( EPN_WORD addr )
{
	EPN_WORD  SeqNum = 0x0500;
	EPN_WORD  ret;

	// AhX͈͊O
	if( addr > 0x24 ) return 0x00;

	// R}ht\Ԃׂ 
	// bit2  1  0 ɂȂƔ
	while( GetFlg() & FLG_COMMAND_FULL );

	// VXe̒[_ɑM
	SetCmd( SeqNum | ENDPOINT_SYSTEM | CMD_SEND );

	// Xe[^XZbgꂽƂF
	while( GetFlg() & FLG_STAUS_FULL != FLG_STAUS_FULL );

	// Xe[^Xǂݏo
	while( GetSts() != ( SeqNum | ENDPOINT_SYSTEM | STS_WRITE ) );

	// Mf[^
	EpnSetDataPort(0x0000);   // 1 0
	// tO
	EpnSetDataPort(0x0000);   // 3 2
	//  & IuWFNg
	EpnSetDataPort(0x0400);   // 5 4

	// ItZbg - AhX
	addr = addr << 8;
	EpnSetDataPort( addr );   // 7 6

	EpnSetDataPort(0x0000);  // 9  8
	EpnSetDataPort(0x0000);  //11 10

	EpnSetDataPort(0x0000);  //13 12
	EpnSetDataPort(0x0000);  //15 14

	// Xe[^XZbgꂽƂF
	while( GetFlg() & FLG_STAUS_FULL != FLG_STAUS_FULL );

	// Xe[^Xǂݏo
	while( GetSts() != ( SeqNum | ENDPOINT_SYSTEM | STS_OK ) );

	// R}ht\Ԃׂ 
	// bit2  1  0 ɂȂƔ
	while( GetFlg() & FLG_COMMAND_FULL );

	// VXe̒[_ɑM
	SetCmd( SeqNum | ENDPOINT_SYSTEM | CMD_RECEIVE );

	// Xe[^XZbgꂽƂF
	while( GetFlg() & FLG_STAUS_FULL != FLG_STAUS_FULL );

	// Xe[^XWX^ READ( 0x02 ) Zbg܂ő҂
	while( GetSts() != ( SeqNum | ENDPOINT_SYSTEM | STS_READ ) );

	// Xe[^XIvVp[^ǂݔ΂( 15 oCg )
	EpnGetDataPort(); EpnGetDataPort(); EpnGetDataPort(); EpnGetDataPort(); 
	EpnGetDataPort(); EpnGetDataPort(); EpnGetDataPort(); 
	
	ret = EpnGetDataPort();

	return ret;
}

void Epn_Reg_WRITE( EPN_WORD addr, EPN_WORD data )
{
	EPN_WORD  SeqNum = 0x0600;

	// AhX͈͊O
	if( addr > 0x24) return;

	// R}ht\Ԃׂ 
	// bit2  1  0 ɂȂƔ
	while( GetFlg() & FLG_COMMAND_FULL );

	// VXe̒[_ɑM
	SetCmd( SeqNum | ENDPOINT_SYSTEM | CMD_SEND );

	// Xe[^XZbgꂽƂF
	while( GetFlg() & FLG_STAUS_FULL != FLG_STAUS_FULL );

	// Xe[^Xǂݏo

	while( GetSts() != ( SeqNum | ENDPOINT_SYSTEM | STS_WRITE ) );

	// Mf[^
	EpnSetDataPort(0x0000);   // 1 0 
	// tO
	EpnSetDataPort(0x0000);   // 3 2
	//  & IuWFNg
	EpnSetDataPort(0x0401);   // 5 4
	// ItZbg - AhX
	addr = addr << 8;
	EpnSetDataPort(addr);    // 7  6
	EpnSetDataPort(0x0000);  // 9  8
	EpnSetDataPort(0x0000);  //11 10
	EpnSetDataPort(0xffff);  //13 12
	data = (data << 8) | (data >> 8);
	EpnSetDataPort( data );  //15 14

	// Xe[^XZbgꂽƂF
	while( GetFlg() & FLG_STAUS_FULL != FLG_STAUS_FULL );

	while( GetSts() != ( SeqNum | ENDPOINT_SYSTEM | STS_OK ) );
}


